import bpy
import os
from .routine import *
from .display import *


def IkplineOtion():
	class line_options(bpy.types.PropertyGroup):

		ikpl_mode: bpy.props.IntProperty(name   ="Graph Mode", default = 0, min = 0, max = 1, description = "Graph mode")
		ikpl_scope: bpy.props.IntProperty(name   ="scope", default = 3, min = 2, max  = 1000000, description = "Progression scope" )
		ikpl_units: bpy.props.FloatProperty(name ="units", default = 2, min = 0.001, max = 1000000.0, description = "Distance connection")
		ikpl_CrvRadius: bpy.props.BoolProperty(name="Curve Radius", default=False, description ="Interpolate radius")
		ikpl_name: bpy.props.StringProperty(name="target", default  = "Self link name")
		ikpl_data: bpy.props.StringProperty(name="target", default  = "-DataStream-")
		ipda_cache: bpy.props.StringProperty(name="target", default  = "time-cache")
		obj_target: bpy.props.StringProperty(name="target", default  = "IK-Particle Link")
		curve_handle: bpy.props.StringProperty(name="curve mode", default  = "AUTO")
		segment: bpy.props.IntProperty(name ="Segment", default = 3, min = 0, max = 64, description = "Split Edge")
		ikpl_branches: bpy.props.IntProperty(name   ="branches", default = 3, min = 1, max = 100000, description = "Conections" )

		ikpl_distance: bpy.props.BoolProperty(name="Distance", default=False, description ="Evaluete distance")
		ikpl_short: bpy.props.BoolProperty(name="Shortest", default=False, description ="Shortest path")
		baking: bpy.props.BoolProperty(name="baking", default=False, description ="Detect baking")
		flow: bpy.props.PointerProperty(name="Start", type=bpy.types.Object, description ="Object position to process flow direction")

	return line_options



def SetHandlesType(self, context):
	"""Interpolation from menu"""

	ch = bpy.context.scene.ik_pl_cur_hand.ik_pl_cur_hand_type
	if getattr(context.scene,  context.object.name , None) == None :
		return None

	Set = eval('context.scene.{S}[0]'.format( S = context.object.name ) )
	Set.curve_handle = ch



class Curve_handles_sett(PropertyGroup):
	ik_pl_cur_hand_type: EnumProperty(
		name="Interpolation Mode:",
		description="Curve handles",
		update = SetHandlesType,		
		items = (
		('AUTO',   "Automatic",	 "","IPO_BEZIER",1),
		('VECTOR',  "Vector", "","IPO_LINEAR",2)),
		default='AUTO', 
		)


def GroupsIKPLineOptionsGenerator(obname ):
	ikpl_options = IkplineOtion()
	new = "{obn}=type('{obn}',ikpl_options.__bases__,dict(ikpl_options.__dict__))".format(obn = obname)
	exec(new)

	bpy.utils.register_class( eval(obname) )
	exec("bpy.types.Scene.{obn} = bpy.props.CollectionProperty(type={obn})".format(obn = obname  ))

	return eval(obname)



def Spline_obj_BuildSettings(spline_obj):
	# Générer Group option par obj
	C = bpy.context
	scene = C.scene

	build_options = GroupsIKPLineOptionsGenerator( spline_obj.name )
	exec( "C.scene.{}.add()".format( spline_obj.name ) )
	options = eval("C.scene.{}[0]".format( spline_obj.name ))

	return options


def recover(obname):
	ikpl_options = IkplineOtion()
	new = "{obn}=type('{obn}',ikpl_options.__bases__,dict(ikpl_options.__dict__))".format(obn = obname)
	exec(new)

	bpy.utils.register_class( eval(obname) )
	exec("bpy.types.Scene.{obn} = bpy.props.CollectionProperty(type={obn})".format(obn = obname  ))

	return eval(obname)




class AddIKpLinkOperator(bpy.types.Operator):
	"""Add IK PL to 3D scene"""
	bl_idname = "object.add_ikplink_operator"
	bl_label = "Link active"
	bl_options = {'REGISTER', 'UNDO'}


	@classmethod
	def poll(cls, context):
		ch = list(el for el in context.active_object.particle_systems) if context.active_object != None else []
		return len(ch) >= 1

	def execute(self, context):

		C   = bpy.context
		D   = bpy.data
		obj = C.scene.objects
		target_name = C.active_object.name 
		target_coll = find_collection(C.active_object)

		name = "".join([c for c in target_name if c.isalpha()])

		#bugfix -- on the name
		group = [o.name for o in C.scene.objects if (o.name.startswith(name) and o.name != target_name)] + [target_name]

		nn = []
		for o in group:
			if o.endswith("_IKPL"):
				o = o.replace("_IKPL","") 
				nn.append(int(re.split('_',o)[-1]) if len(re.split('_',o)) > 1 else 0)
			else:
				nn.append(0)


		num   = len( group ) + max(nn)
		name  = name + "_" + str(num) + "_IKPL" 

		objname = curvename = name

		curvedata = bpy.data.curves.new(name=curvename, type='CURVE')	
		curvedata.dimensions = '3D'	
		
		spline_obj = bpy.data.objects.new(objname, curvedata)	
		spline_obj.location = (0,0,0) #object origin	
		
		#bpy.context.scene.objects.link(spline_obj) 
		mooveToCollection(bpy.data.objects[curvename], target_coll, unlink=False)

		Settings = Spline_obj_BuildSettings(spline_obj)
		
		Settings.obj_target	=  str([target_name, list(ps.name for ps in C.object.particle_systems)[C.object.particle_systems.active_index] ])
		Settings.ikpl_name	=  curvename

		#save on disque
		IKPLCurveData(objname)# curve mapping
		Disque = eval(bpy.context.scene.IKPLinks)
		Disque.append( objname  )
		bpy.context.scene.IKPLinks = str(Disque)

		bpy.ops.object.select_all(action='DESELECT')
		context.view_layer.objects.active = bpy.data.objects[ objname ]
		context.active_object.select_set(state=True)

		if (2, 92, 0) <= bpy.app.version:
			bpy.data.objects[ objname ].data.bevel_mode = 'OBJECT'

		return {'FINISHED'}



class RecoverBackOperator(bpy.types.Operator):
	"""Relod from last session"""
	bl_idname = "object.ik_pl_reload_op"
	bl_label = "Reload animation from last session"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		Disque = eval(bpy.context.scene.IKPLinks)
		check  = Disque[0] if len(Disque) > 0 else "-_-_-"
		return getattr( context.scene, check, None) == None 

	def execute(self, context):
		Disque = eval(context.scene.IKPLinks)

		for ob in context.scene.objects:
			if ob.name.endswith("_IKPL") and ob.name in Disque:
				recover(ob.name)

				sett = eval("context.scene.{o}[0]".format( o= ob.name ) )
		return {'FINISHED'}




class RefreshePLOperator(bpy.types.Operator):
	"""Update current frame"""
	bl_idname = "object.ik_ref_pl_op"
	bl_label = "Refreshe IKPL"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		return (context.object.name in  eval(bpy.context.scene.IKPLinks)) if context.object != None else False

	def execute(self, context):
		runikpl()
		return {'FINISHED'}




class OptimizePLOperator(bpy.types.Operator):
	"""Update current frame"""
	bl_idname = "object.ik_optimize_pl_op"
	bl_label = "Optimize"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		if not context.object in context.selected_objects: return False
		return (context.object.name in  eval(bpy.context.scene.IKPLinks)) if context.object != None else None

	def execute(self, context):
		Set = eval('bpy.context.scene.{p}[0]'.format( p = context.object.name ) )
		bevel_ob = context.object.data.bevel_object
		opti = [context.object.data, bevel_ob.data if bevel_ob else None]
		for ob in opti:
			if ob == None: continue
			ob.resolution_u = 1
			Set.segment = 6
		return {'FINISHED'}




class ErasePLOperator(bpy.types.Operator):
	"""Update current frame"""
	bl_idname = "object.ik_erase_pl_op"
	bl_label = "Erase PL"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		if not context.object in context.selected_objects: return False
		return (context.object.name in  eval(bpy.context.scene.IKPLinks)) if context.object != None else False

	def execute(self, context):
		efacer(context.object.name)
		bpy.ops.object.delete(use_global=False)
		return {'FINISHED'}




class BakePLOperator(bpy.types.Operator):
	"""Update current frame"""
	bl_idname  = "object.ik_bake_pl_op"
	bl_label   = "Bake Particle links"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		if not context.object in context.selected_objects: return False
		return (context.object.name in  eval(bpy.context.scene.IKPLinks)) if context.object != None else False


	def execute(self, context):
		obname = context.active_object.name if context.object != None else "666999"
		slots = context.active_object.material_slots
		Mat = context.active_object.material_slots[0].material if len(slots) > 0 else None
		
		if getattr(context.scene,  obname , None) == None :
			ShowMessageBox("Path trouble, ensure path ends up with '%s'"%op.path.sep)
			return {'CANCELLED'}

		if not os.path.exists(context.scene.ikpl_cache_path):
			ShowMessageBox("Fail to save cache to selected folder", "Path trouble", 'ERROR')
			return {'CANCELLED'}

		Set = eval('context.scene.{S}[0]'.format( S = obname ) )
		obj = bpy.context.scene.objects[obname]
		

		start = context.scene.frame_start
		end = context.scene.frame_end

		wm = bpy.context.window_manager # progress 
		tot = end-start
		wm.progress_begin(0, tot+1)
				
		Set.baking = True
		for i in range (start,end+1):
			numb = "%6d"%i
			bpy.context.scene.frame_set(i)
			filename = os.path.join(context.scene.ikpl_cache_path, obname+"_"+numb.replace(" ","0") + ".abc")

			bpy.ops.wm.alembic_export(filepath=filename,
							selected=True, 
							start=i,
							end=i,
							flatten=True, 
							normals=True, 
							face_sets=True, 
							subdiv_schema=True, 
							apply_subdiv=True, 
							curves_as_mesh=True,
							#renderable_only=False,
							#visible_layers_only=False, 
							quad_method='SHORTEST_DIAGONAL',
							ngon_method='BEAUTY', 
							global_scale=1, 
							#triangulate=True,
							uvs=False, 
							packuv=False,  
							vcolors=False, 
							export_hair=False, 
							as_background_job=False,
							export_particles=False)
			wm.progress_update(i)

		bakedf = obname+"_"+"000000"+".abc"
		baked = os.path.join(context.scene.ikpl_cache_path, bakedf)
		bpy.ops.cachefile.open(filepath=baked)

		#needed for Blender 2.80
		obj.select_set(True)
		bpy.context.view_layer.objects.active = obj
		bpy.context.view_layer.update()

		if (2, 81, 0) >= bpy.app.version:
			bpy.ops.object.delete(use_global=False)
			bpy.ops.mesh.primitive_cube_add(enter_editmode=False, location=(0,0,0))
			context.object.name =  obname
		else:
			bpy.ops.object.convert(target='MESH', keep_original=False)


		bpy.ops.object.modifier_add(type='MESH_SEQUENCE_CACHE')
		modifier = context.object.modifiers[-1]
		modifier.name = "IKPLINKS"
		cahche = modifier.cache_file = bpy.data.cache_files.get(bakedf)
		cahche.is_sequence = True
		
		cahche.override_frame = False
		driv = cahche.driver_add("frame") 
		driv.driver.expression = "frame"

		outName_path = ""

		bpy.context.view_layer.update()
		for ob_path in cahche.object_paths:
			if ob_path.path.startswith("/%s/" % obname):
				outName_path = ob_path.path
				break
			
		modifier.object_path = outName_path 

		context.object.name += "_Baked"

		# get back materials
		if Mat is not None:
			context.object.data.materials.clear()
			context.object.data.materials.append(Mat)
			
		wm.progress_end()

		return {'FINISHED'}




class SlicerOperator(bpy.types.Operator):
	"""slice selected stream"""
	bl_idname = "object.ik_pl_slicer_op"
	bl_label = "Reload animation from last session"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		return (context.object.name in  eval(bpy.context.scene.IKPLinks)) if context.object != None else False

	def execute(self, context):
		obj = context.active_object
		Disque = eval(bpy.context.scene.IKPLinks)
		
		def curvesliser(liste):
			pa = 1/len(liste)
			return [[pa*(el-1) , (pa*el) ] for el in range(1, len(liste)+1)]

		liste = [o for o in obj.children if o.name in Disque] + [obj]
		sett = curvesliser(liste)

		for ob, st in zip(liste, sett):
			ob.data.bevel_factor_start,	ob.data.bevel_factor_end = st[0], st[1]

		return {'FINISHED'}



class RelodCacheOperator(bpy.types.Operator):
	"""Relod cache"""
	bl_idname = "object.ik_pl_dacache"
	bl_label = "Reload animation from last session"
	bl_options = {'REGISTER', 'UNDO'}

	@classmethod
	def poll(cls, context):
		look = eval(context.scene.IKPLinks)
		return len(look) != 0

	def execute(self, context):
		C = context; D = bpy.data; scene = C.scene;

		Disque = eval(context.scene.IKPLinks)

		if ( C.object.name in Disque ) and ( getattr( C.scene, C.object.name , None) != None ) :
			Set = eval("context.scene.{o}[0]".format( o= C.object.name ) )
			Set.ipda_cache = str(time.time())
		return {'FINISHED'}
