from bpy.utils import register_class
from bpy.utils import unregister_class

from .ParticleLink import *
from . import translate
import bpy

import tempfile



classes = (
		Curve_handles_sett,
		AddIKpLinkOperator,
		RecoverBackOperator,
		RefreshePLOperator,
		ErasePLOperator,
		BakePLOperator,
		SlicerOperator,
		RelodCacheOperator,
		PARTICLES_PT_view3d_panel,
		LSETTINGS_PT_view3d_panel,
		OptimizePLOperator,
		BAKING_PT_view3d_panel,
		LINKS_PT_view3d_panel,
		BAVELGEO_PT_view3d_panel,
		)



@persistent
def IkPL_LIK(scene):
	runikpl()


@persistent
def READY(scene):
    """Print ready to use"""
    print("PARTICLES LINK V%s READY"%str(bpy.app.version))


def register():
	
	for cls in classes:
		register_class(cls)

	#bpy.utils.register_module(__name__)
	bpy.types.Scene.ik_pl_cur_hand = bpy.props.PointerProperty(type=Curve_handles_sett)
	bpy.types.Scene.IKPLinks =		 bpy.props.StringProperty(name="Splne mode", default  = "[]")
	bpy.types.Scene.ikpl_cache_path = bpy.props.StringProperty \
        (
        name = "Cache Folder",
        default = tempfile.gettempdir(),
        description = "Define cache folder",
        subtype = 'FILE_PATH'
        )
	
	handlers =[IkPL_LIK ] 
	for name in handlers: bpy.app.handlers.frame_change_post.append(name)

	bpy.app.handlers.load_post.append(READY)
	translate.register()


def unregister():
	handlers =[ "IkPL_LIK"] 
	for name in handlers:
		my_handler_list = bpy.app.handlers.frame_change_post# scene_update_pre frame_change_pre
		fin = len(my_handler_list)

		for idx, func in enumerate(reversed(my_handler_list)):
			if func.__name__.startswith(name) :
				my_handler_list.pop(fin-1-idx)

	sett = eval(bpy.context.scene.IKPLinks) 
	#bpy.utils.unregister_module(__name__)

	for cls in reversed(classes):
		unregister_class(cls)


	del bpy.types.Scene.IKPLinks  
	del bpy.types.Scene.ik_pl_cur_hand 
	del bpy.types.Scene.ikpl_cache_path

	for st in sett:
		if getattr(bpy.context.scene,  st , None) != None :
			exec( "del bpy.types.Scene.%s"%st)

	translate.unregister()
#live editing
# if __name__ == "__main__":
# 	register()

