﻿import bpy
import os
from .routine import *


class BAKING_PT_view3d_panel(bpy.types.Panel):
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'UI'
	bl_label = "Baking"
	bl_parent_id = 'PARTICLES_PT_view3d_panel' #onglais
	bl_context = 'objectmode'
	bl_category = "Particles Link"
	#bl_options = {'DEFAULT_CLOSED'}

	def draw(self, context):
		layout = self.layout
		scene = context.scene


		row = layout.row(align=True)
		row.operator("object.ik_optimize_pl_op", icon="MOD_REMESH" )
		row.operator("object.ik_bake_pl_op", icon="FILE_TICK",  text="Bake" )

		row = layout.row()
		row.prop(scene, 'ikpl_cache_path', text="", icon="FILE_CACHE")
		
		if not os.path.exists(scene.ikpl_cache_path):
			row = layout.row(align=True)
			folder = scene.ikpl_cache_path.split(os.path.sep)[-1]
			row.label(text="No '%s' folder at this location" %
						folder, icon='ERROR')



class LSETTINGS_PT_view3d_panel(bpy.types.Panel):
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'UI'
	bl_label = "Link settings"
	bl_parent_id = 'PARTICLES_PT_view3d_panel' #onglais
	bl_context = 'objectmode'
	bl_category = "Particles Link"
	#bl_options = {'DEFAULT_CLOSED'}

	def draw(self, context):
		layout = self.layout
		scene = context.scene
		C = context

		row = layout.row(align=False)

		if not C.active_object == None:

			Disque = eval(bpy.context.scene.IKPLinks)

			if ( C.object.name in Disque ) and ( getattr( C.scene, C.object.name , None) != None ) :

				cve_name  = C.object.name	
				sett  = eval('scene.{S}[0]'.format( S = cve_name ) )
				dalink	= sett.ikpl_data
				mode = sett.ikpl_mode
				
				
				modic = ["GP_ONLY_SELECTED", "MESH_DATA"]
				modtx = ["Flow line", "Network"]

				row = layout.row(align=True)
				row.label(text=modtx[mode], icon = modic[mode])
				row.operator("object.ik_ref_pl_op", icon="FILE_REFRESH", text ="" )

				row = layout.row(align=True)
				row.prop(sett, "ikpl_mode", text="Mode" )

				if mode == 0:
					row = layout.row(align=True)
					row.prop(sett, "ikpl_distance", icon="CON_FOLLOWTRACK")
					row.prop(sett, "ikpl_short", icon="GP_MULTIFRAME_EDITING")


				if mode == 1:
					row = layout.row(align=True)
					row.prop(sett, "ikpl_units", text="Distance")
					row.prop(sett, "ikpl_branches", text="Branches")

				row = layout.row(align=True)
				row.prop(sett, "flow", text="")#

				


class PARTICLES_PT_view3d_panel(bpy.types.Panel):
	bl_label = "Particles Link"
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'UI'
	bl_context = 'objectmode'
	bl_category = "IK-PL"


	def draw(self, context):
		C = bpy.context
		D = bpy.data
		scene = C.scene
		layout = self.layout

		row = layout.row()
		row.operator("object.add_ikplink_operator", icon="PARTICLE_POINT" )
		row.operator("object.ik_erase_pl_op", icon="TRASH" )

		row = layout.row()
		row.operator("object.ik_pl_reload_op", icon="SCENE_DATA", text ="Recover Session" )

		



class BAVELGEO_PT_view3d_panel(bpy.types.Panel):
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'UI'
	bl_label = "Bevel"
	bl_parent_id = 'LINKS_PT_view3d_panel' #onglais
	bl_context = 'objectmode'
	bl_category = "Particles Link"
	bl_options = {'DEFAULT_CLOSED'}


	def draw(self, context):
		def draw_bevel(context, layout, curve):
			layout.prop(curve, "bevel_mode", expand=True)
			layout.use_property_split = True

			col = layout.column()
			if curve.bevel_mode == 'OBJECT':
				col.prop(curve, "bevel_object", text="Object")
			else:
				col.prop(curve, "bevel_depth", text="Depth")
				col.prop(curve, "bevel_resolution", text="Resolution")
			col.prop(curve, "use_fill_caps")

			if curve.bevel_mode == 'PROFILE':
				col.template_curveprofile(curve, "bevel_profile")
			
			row = layout.row()
			row.prop(curve, "bevel_factor_start", text="Factor Start")
			row.prop(curve, "bevel_factor_end", text="End")



		layout = self.layout
		scene = context.scene
		obj = bpy.context.object

		if not context.active_object == None:
			if obj.name.endswith("_IKPL") and obj.type == 'CURVE': # selected curve options

				if (2, 90, 0) < bpy.app.version:
					draw_bevel(context, layout, obj.data)
				else:
					row = layout.row(align=True)
					row.prop(obj.data, 'bevel_resolution', text="Resolution")
					row.prop(obj.data, 'resolution_u')

					row = layout.row()
					row.prop(obj.data, 'bevel_object', text="")
					row.prop(obj.data, 'use_fill_caps', text="")

					row = layout.row(align=True)
					row.prop(obj.data, 'bevel_factor_start', text="Clip Start")
					row.prop(obj.data, 'bevel_factor_end', text="Clip snd")

			
		


class LINKS_PT_view3d_panel(bpy.types.Panel):
	bl_label = "Geometry"
	bl_space_type = 'VIEW_3D'
	bl_region_type = 'UI'
	bl_context = 'objectmode'
	bl_category = "IK-PL"
	bl_options = {'DEFAULT_CLOSED'}

	def draw(self, context): 
		layout = self.layout
		obj = bpy.context.object
		interpolation_tool = context.scene.ik_pl_cur_hand					 #----------------Interpolation

		if not context.active_object == None:
			if obj.name.endswith("_IKPL") and obj.type == 'CURVE': # selected curve options

				
				row = layout.row()
				row.prop(interpolation_tool, "ik_pl_cur_hand_type", text="") #---------------Interpolation

				row = layout.row()
				row.prop(obj.data, 'extrude')
				if obj.data.bevel_mode == "ROUND" or obj.data.bevel_mode == "PROFILE":
					row.enabled = True
				else:
					row.enabled = False


				# row = layout.row()
				# row.prop(obj.data, 'bevel_depth', text="Tubify")
				
				

				Disque = eval(context.scene.IKPLinks)
				if ( obj.name in Disque ) and ( getattr( context.scene, obj.name , None) != None ) :

					Settings  = eval('context.scene.{S}[0]'.format( S = obj.name ) )
					Radius	= Settings.ikpl_CrvRadius

					row = layout.row(align=False)
					row.prop(Settings, 'segment', text="Resolution", icon="MOD_DECIM")
					
					row = layout.row(align=False)
					row.prop(Settings, 'ikpl_CrvRadius', text="Curve shape", icon="MOD_FLUIDSIM")

					if Radius:
						ng = bpy.data.node_groups #--------------------curve maping 
						if getattr(ng,  'IKPLCurveData' , None) == None :
							ipaint  = ng['IKPLCurveData'].nodes[obj.name]
																			
							box = layout.box()
							col = box.column(align = True)
							col.template_curve_mapping(ipaint, "mapping")

